# CAPS client library

This file describes how to build the CAPS client library from source.

## Runtime Dependencies

* Boost
	* Program options
	* Filesystem
	* System
* OpenSSL
* Python*

### Installation

#### Ubuntu 14.04
```
sudo apt-get install libboost-filesystem1.54.0 libboost-program-options1.54.0 libboost-system1.54.0 libssl0.9.8
```

#### Ubuntu 16.04
```
sudo apt-get install libboost-filesystem1.58.0 libboost-program-options1.58.0 libboost-system1.58.0 libssl1.0.0
```

#### Ubuntu 18.04
```
sudo apt-get install libboost-filesystem1.65.1 libboost-program-options1.65.1 libboost-system1.65.0 libssl1.1
```

#### Ubuntu 20.04
```
sudo apt install libboost-filesystem1.71.0 libboost-program-options1.71.0 libboost-system1.71.0 libssl1.1
```

#### RHEL/CentOS
```
yum install boost-filesystem boost-program-options boost-system openssl
```

## Build Dependencies

* CMake
* GCC, G++
* Boost
* OpenSSL
* Swig*

### Installation

#### Ubuntu
```
 sudo apt-get install cmake gcc g++ libboost-all-dev cmake-curses-gui make libssl-dev
```
#### RHEL/CentOS
```
yum install cmake gcc-c++ openssl-devel boost-devel
```

## Build

1. Extract the package
```
tar xf libcapsclient-1.0.0.tar.gz
```
2. Change working directory and create a build directory
```
cd libcapsclient
mkdir build
cd build
```
3. Setup build environment
```
ccmake ..
```
4. Adjust the CMake settings to your needs
   1. Press 'c'
   2. Change the installation directory
   3. Switch on/off features e.g. examples
   4. ...
5. Press 'c' two time followed by 'g' to generate the build configuration
6. Build and install
```
make install
```
