/***************************************************************************
 * Copyright (C) 2018 by gempa GmbH
 *
 * Author: Stephan Herrnkind
 * Email: herrnkidn@gempa.de
 ***************************************************************************/


#ifndef GEMPA_CAPS_VERSION_H
#define GEMPA_CAPS_VERSION_H


/* #if (LIB_CAPS_VERSION >= LIB_CAPS_VERSION_CHECK(1, 0, 0)) */
#define LIB_CAPS_VERSION_CHECK(major, minor, patch) ((major<<16)|(minor<<8)|(patch))

#define LIB_CAPS_VERSION_MAJOR(v) (v >> 16)
#define LIB_CAPS_VERSION_MINOR(v) ((v >> 8) & 0xff)
#define LIB_CAPS_VERSION_PATCH(v) (v & 0xff)

/* LIB_CAPS_VERSION is (major << 16) + (minor << 8) + patch. */
#define LIB_CAPS_VERSION 0x010000
#define LIB_CAPS_VERSION_NAME "2.0.0"

/******************************************************************************
 API Changelog
 ******************************************************************************
 "2.0.0"   0x020000
   - Add Plugin::setAddress
   - Add Plugin::flushEncoders
   - Add Plugin::dumpPackets
   - Add Plugin::packetBuffer
   - Add Plugin::setAgent
   - Add Plugin::getAPIVersion
   - Change Plugin memory layout

 "1.0.0"   0x010000
   - Initial version

*/

#endif // GEMPA_CAPS_VERSION_H
